var language;
if (window.navigator.languages) {
    language = window.navigator.languages[0];
} else {
    language = window.navigator.userLanguage || window.navigator.language;
}
console.log(language);
if(language.indexOf('zh') == -1 && language.indexOf('-') > -1){
    var language = language.split('-')[0];
}

chrome.runtime.onInstalled.addListener(function (details) {
    //console.log(details)
    if (details.reason == 'install') {
        chrome.tabs.create({
            url: 'https://fbion.com/'+language+'/bilibili-downloader.html?install='+chrome.runtime.getManifest().version
        });
    } else if(details.reason == 'update'){
        chrome.tabs.create({
            url: 'https://fbion.com/'+language+'/bilibili-downloader.html?update='+chrome.runtime.getManifest().version
        });
    }
});

if(chrome.runtime.setUninstallURL) {
    chrome.runtime.setUninstallURL('https://fbion.com/'+language+'/bilibili-downloader.html?uninstall='+chrome.runtime.getManifest().version);
}

var isbackground = 1;
var latest_play = '';
var _files = [];
var _urls = [];
var _downloads = [];
var _progresses = [];

var _ts = [];
var _blobs = [];
var _savename, _formatselected;
var prefix = 'ext_';
var downloadstream_stop = 0;
var started_at = 0;
var isFirefox = navigator.userAgent.toLowerCase().indexOf('firefox') > -1;
function extractHostname(url) {
    var hostname;
    if (url.indexOf("//") > -1) {
        hostname = url.split('/')[2];
    }
    else {
        hostname = url.split('/')[0];
    }
    hostname = hostname.split(':')[0];
    hostname = hostname.split('?')[0];
    return hostname;
}
if(isFirefox){
    browser.webRequest.onBeforeSendHeaders.addListener(function(details) {
        var newRef = "https://www.bilibili.com";
        var referer = details.requestHeaders.find(e => e.name.toLowerCase() === 'referer');
        if (referer) {
            referer.value = newRef;
        } else {
            details.requestHeaders.push({
                name: "referer",
                value: newRef,
            });
        }
        return {
            requestHeaders: details.requestHeaders
        };
    }, {
        urls: ["*://*.acgvideo.com/*","https://comment.bilibili.com/*","*://*.hdslb.com/*"]
    }, [
        "requestHeaders",
        "blocking"
    ]);
    browser.webRequest.onHeadersReceived.addListener(details => {
        if(details.url==undefined) return;
        if(isFirefox) {
            if(details.documentUrl!=undefined) details.initiator = details.documentUrl.split('://')[0]+'://'+extractHostname(details.documentUrl);
        }
        var isbilibili = details.initiator.indexOf('bilibili.com') > -1;
        if(isbilibili) return;
        var header = details.responseHeaders.find(e => e.name.toLowerCase() === 'access-control-allow-origin');
        var newValue = '*';
        if (header) {
            header.value = newValue;
        } else {
            details.responseHeaders.push({
                name: "access-control-allow-origin",
                value: newValue,
            });
        }
        return {
            responseHeaders: details.responseHeaders
        };
    }, {
        urls: ['https://comment.bilibili.com/*','*://api.bilibili.com/*']
    }, ['blocking', 'responseHeaders']);
}
else{
    chrome.webRequest.onBeforeSendHeaders.addListener(function(details) {
        var newRef = "https://www.bilibili.com";
        var referer = details.requestHeaders.find(e => e.name.toLowerCase() === 'referer');
        if (referer) {
            referer.value = newRef;
        } else {
            details.requestHeaders.push({
                name: "referer",
                value: newRef,
            });
        }
        return {
            requestHeaders: details.requestHeaders
        };
    }, {
        urls: ["*://*.acgvideo.com/*","https://comment.bilibili.com/*","*://*.hdslb.com/*"]
    }, [
        "requestHeaders",
        "blocking",
        "extraHeaders"
    ]);
    chrome.webRequest.onHeadersReceived.addListener(details => {
        if(details.url==undefined) return;
        if(isFirefox) {
            if(details.documentUrl!=undefined) details.initiator = details.documentUrl.split('://')[0]+'://'+extractHostname(details.documentUrl);
        }
        var isbilibili = details.initiator.indexOf('bilibili.com') > -1;
        if(isbilibili) return;
        var header = details.responseHeaders.find(e => e.name.toLowerCase() === 'access-control-allow-origin');
        var newValue = '*';
        if (header) {
            header.value = newValue;
        } else {
            details.responseHeaders.push({
                name: "access-control-allow-origin",
                value: newValue,
            });
        }
        return {
            responseHeaders: details.responseHeaders
        };
    }, {
        urls: ['https://comment.bilibili.com/*','*://api.bilibili.com/*']
    }, ['blocking', 'responseHeaders']);
}
chrome.runtime.onMessage.addListener(function(request, sender, sendResponse) {
    if (request.action == "getData")
    {
        sendResponse({data: _files,urls:_urls,latest:latest_play});
    }
    else if (request.action == "add")
    {
        //console.log(request);
        //console.log(_urls);
        canadd = 0;
        if(_urls.indexOf(request.data.id)==-1){
            _urls.push(request.data.id);
            canadd = 1;
        }
        if(canadd==1){
            _files.push(request.data);
            //chrome.browserAction.setBadgeText({text:_files.length.toString()});
        }
        else{
            var k = _urls.indexOf(request.data.id);
            _files[k] = request.data;
        }
        sendResponse({data: 'done'});
    }
});
analytics_get(['background','start']);