(function() {
    console.log('bilibili.js');
    /*if(auto_disable!=undefined){
        if(auto_disable==1) return;
    }*/
    var bilibili_title = '';
    var bilibili_url = '';
    var language;
    var hoverPlayer = document.querySelector(".dmp_VideoView");
    var video_config, video_id, page_id, page_index;
    var pages = [];
    var callback_data = {
        title: '',
        formats:[],
        streams:[],
        link: ''
    };
    if (window.navigator.languages) {
        language = window.navigator.languages[0];
    } else {
        language = window.navigator.userLanguage || window.navigator.language;
    }
    if(language.indexOf('zh') == -1 && language.indexOf('-') > -1){
        var language = language.split('-')[0];
    }
    var fbion_div = document.getElementById('fbion');
    if(fbion_div==null){
        console.log('insert fbion div');
        var fbion = document.createElement('div');
        fbion.id = 'fbion';
        document.body.appendChild(fbion);
    }
    function explorer(pattern) {
        var scripts = document.getElementsByTagName('script');
        for (var i = 0; i < scripts.length; i++) {
            var script = scripts[i];
            //console.log(script)
            //console.log(script.text)
            var match = pattern.exec(script.text);
            if (match !== null) {
                return match;
            }
        }
        return null;
    }

    var video_url = /:\/\/www\.bilibili\.com\/video\/.*/g.test(document.URL);
    var bangumi_url = /:\/\/www\.bilibili\.com\/bangumi\/play\/.*/g.test(document.URL);
    var embed_url = /:\/\/player\.bilibili\.com\/player\.html.*/g.test(document.URL);
    var live_url = /:\/\/live\.bilibili\.com\/.*/g.test(document.URL);
    var page_index = 1, poster = '', tags = [], title = '', link = '';
    if (video_url) {
        var player_container = document.querySelector("#bilibiliPlayer");
        if (player_container === null) {
            console.log('error '+document.URL);
            return {
                status: 'player_undefined'
            };
        }
        if(document.URL.indexOf('video/av') > -1) var bilibili_id = /video\/(.*)/g.exec(document.URL);
        else var bilibili_id = /video\/(.*)/g.exec(document.querySelector('link[rel="canonical"]').getAttribute('href'));
        if (bilibili_id === null) {
            console.log('bilibili id '+player_container.id+' '+document.URL);
            return {
                status: 'player_undefined'
            };
        }
        video_id = bilibili_id[1];
        if(video_id.indexOf('?')>-1) video_id = video_id.split('?')[0];
        video_id = video_id.replace('/','').replace('av','');
        console.log('video_id '+video_id);
        try{
            var url = new URL(document.URL);
            page_index = url.searchParams.get("p");
            if(page_index==null) page_index = 1;
            poster = document.querySelector('meta[itemprop="thumbnailUrl"]').getAttribute('content').replace('http:','https:');
            var h1 = document.querySelector('h1').getAttribute('title');
            tags = document.querySelector('meta[name="keywords"]').getAttribute('content').replace(h1+',','').trim().split(',');
            title = document.title;
            link = document.URL;
        } catch(err){
            console.log(err);
            return {
                status: 'player_undefined'
            };
        }
        if(fbion_div!=null){
            chrome.runtime.sendMessage({action: "loader",id: video_id,index: page_index, title: title, poster: poster,tags: tags,link: link});
            return {
                status: 'loader_processing'
            };
        }
        var __playinfo__ = explorer(/__playinfo__={(.*)}/gm);
        var __INITIAL_STATE__ = explorer(/__INITIAL_STATE__={(.*)}/gm);
        //console.log(__playinfo__)
        //console.log(__INITIAL_STATE__)
        if(__INITIAL_STATE__!==null){
            var o = JSON.parse('{'+__INITIAL_STATE__[1]+'}');
            //console.log(o);
        }
        if(__playinfo__!==null){
            var o = JSON.parse('{'+__playinfo__[1]+'}');
            //console.log(o);
            chrome.runtime.sendMessage({action: "parse",id: video_id,index: page_index, title: title, poster: poster,tags: tags,link: link,data: o});
            return {
                status: 'loader_processing'
            };
        }
        else{
            chrome.runtime.sendMessage({action: "loader",id: video_id,index: page_index, title: title, poster: poster,tags: tags,link: link});
            return {
                status: 'loader_processing'
            };
        }
        return {
            status: 'player_undefined'
        };
    }
    else if(embed_url){
        //console.log(embed_url);
        try{
            var url = new URL(document.URL);
            video_id = url.searchParams.get("aid");
            page_index = url.searchParams.get("page");
            if(page_index==null) page_index = 1;
            poster = document.querySelector('meta[itemprop="thumbnailUrl"]').getAttribute('content').replace('http:','https:');
            var h1 = document.querySelector('h1').innerText;
            tags = document.querySelector('meta[name="keywords"]').getAttribute('content').replace(h1+',','').trim().split(',');
            title = document.title;
            link = document.URL;
        } catch(err){
            return {
                status: 'player_undefined'
            };
        }
        chrome.runtime.sendMessage({action: "loader",id: video_id,index: page_index, title: title, poster: poster,tags: tags,link: link});
    }
    else if (bangumi_url) {
        var player_container = document.querySelector("#bilibiliPlayer");
        if (player_container === null) {
            console.log('error '+document.URL);
            return {
                status: 'player_undefined'
            };
        }
        var bilibili_id = /play\/(.*)/g.exec(document.URL);
        if (bilibili_id === null) {
            console.log('bilibili id '+player_container.id+' '+document.URL);
            return {
                status: 'player_undefined'
            };
        }
        video_id = bilibili_id[1];
        if(video_id.indexOf('?')>-1) video_id = video_id.split('?')[0];
        video_id = video_id.replace('/','').replace('av','');
        console.log('video_id '+video_id);
        try{
            var url = new URL(document.URL);
            page_index = 1;
            poster = document.querySelector('meta[property="og:image"]').getAttribute('content');
            var h1 = document.querySelector('h1').getAttribute('title');
            tags = document.querySelector('meta[name="keywords"]').getAttribute('content').replace(h1+',','').trim().split(',');
            title = document.title;
            link = document.URL;
            video_id = document.querySelector('.av-link').innerText.replace(/[^0-9]/g,'');
        } catch(err){
            return {
                status: 'player_undefined'
            };
        }
        if(fbion_div!=null){
            chrome.runtime.sendMessage({action: "loader",id: video_id,index: page_index, title: title, poster: poster,tags: tags,link: link});
            return {
                status: 'loader_processing'
            };
        }
        var __playinfo__ = explorer(/__playinfo__={(.*)}/gm);
        if(__playinfo__!==null){
            var o = JSON.parse('{'+__playinfo__[1]+'}');
            //console.log(o);
            chrome.runtime.sendMessage({action: "parse",id: video_id,index: page_index, title: title, poster: poster,tags: tags,link: link,data: o});
            return {
                status: 'loader_processing'
            };
        }
        else{
            chrome.runtime.sendMessage({action: "loader",id: video_id,index: page_index, title: title, poster: poster,tags: tags,link: link});
            return {
                status: 'loader_processing'
            };
        }
        return {
            status: 'player_undefined'
        };
    }
    else if(live_url){
        return {
            status: 'player_undefined'
        };
        try{
            var __liveinfo__ = explorer(/__NEPTUNE_IS_MY_WAIFU__={(.*)}/gm);
            if(__liveinfo__!==null){
                var o = JSON.parse('{'+__liveinfo__[1]+'}');
                //console.log(o);
                callback_data = {
                    poster: o.baseInfoRes.data.user_cover,
                    thumbnails: [o.baseInfoRes.data.keyframe]
                }
            }
            var bilibili_id = /live\.bilibili\.com\/(.*)/g.exec(document.URL);
            if (bilibili_id === null) {
                console.log('bilibili id '+player_container.id+' '+document.URL);
                return {
                    status: 'player_undefined'
                };
            }
            video_id = bilibili_id[1];
            if(video_id.indexOf('?')>-1) video_id = video_id.split('?')[0];
            video_id = video_id.replace(/[^0-9]/ig,'');
            if(video_id==''){
                return {
                    status: 'player_undefined'
                };
            }
            console.log('video_id '+video_id);
            var h1 = document.querySelector('h1').innerText;
            tags = document.querySelector('meta[name="keywords"]').getAttribute('content').replace(h1+',','').trim().split(',');
            title = document.title;
            link = document.URL;
        } catch(err){
            return {
                status: 'player_undefined'
            };
        }
        chrome.runtime.sendMessage({action: "live",id: video_id,title: title,tags: tags,link: link,data: callback_data});
    }

    return {
        status: 'player_undefined'
    };
})();